import { IgrGeographicMapImagery } from "./igr-geographic-map-imagery";
import { OpenStreetMapImagery as OpenStreetMapImagery_internal } from "./OpenStreetMapImagery";
/**
 * UI element class used to display OpenStreetMap imagery in the IgxGeographicMap.Component
*/
export class IgrOpenStreetMapImagery extends IgrGeographicMapImagery {
    createImplementation() {
        return new OpenStreetMapImagery_internal();
    }
    /**
                                 * @hidden
                                 */
    get i() {
        return this._implementation;
    }
    constructor() {
        super();
    }
    /**
     * Gets or sets the tile path URL.
    */
    get tilePath() {
        return this.i.tilePath;
    }
    set tilePath(v) {
        this.i.tilePath = v;
    }
}
