import { IgrShapeSeriesBase } from "igniteui-react-charts";
import { TileSeries } from "./TileSeries";
/**
 * Represents a tile series class that can render imagery tiles
*/
export class IgrTileSeries extends IgrShapeSeriesBase {
    createImplementation() {
        return new TileSeries();
    }
    /**
                                 * @hidden
                                 */
    get i() {
        return this._implementation;
    }
    constructor(props) {
        super(props);
    }
    /**
     * Gets whether the current series shows a tile imagery.
    */
    get isTile() {
        return this.i.f4;
    }
    /**
     * The MapImagery which is used to provide the tiles for display.
    */
    get tileImagery() {
        const r = this.i.aag;
        if (r == null) {
            return null;
        }
        return r.externalObject;
    }
    set tileImagery(v) {
        v == null ? this.i.aag = null : this.i.aag = v.i;
    }
    findByName(name) {
        var baseResult = super.findByName(name);
        if (baseResult) {
            return baseResult;
        }
        if (this.tileImagery && this.tileImagery.name && this.tileImagery.name == name) {
            return this.tileImagery;
        }
        return null;
    }
    /**
     * Defers rendering of the series
    
    */
    deferredRefresh() {
        this.i.deferredRefresh();
    }
}
