import { __extends } from "tslib";
import { IgrShapeSeriesBase } from "igniteui-react-charts";
import { TileSeries } from "./TileSeries";
/**
 * Represents a tile series class that can render imagery tiles
*/
var IgrTileSeries = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgrTileSeries, _super);
    function IgrTileSeries(props) {
        return _super.call(this, props) || this;
    }
    IgrTileSeries.prototype.createImplementation = function () {
        return new TileSeries();
    };
    Object.defineProperty(IgrTileSeries.prototype, "i", {
        /**
                                     * @hidden
                                     */
        get: function () {
            return this._implementation;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrTileSeries.prototype, "isTile", {
        /**
         * Gets whether the current series shows a tile imagery.
        */
        get: function () {
            return this.i.f4;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrTileSeries.prototype, "tileImagery", {
        /**
         * The MapImagery which is used to provide the tiles for display.
        */
        get: function () {
            var r = this.i.aag;
            if (r == null) {
                return null;
            }
            return r.externalObject;
        },
        set: function (v) {
            v == null ? this.i.aag = null : this.i.aag = v.i;
        },
        enumerable: false,
        configurable: true
    });
    IgrTileSeries.prototype.findByName = function (name) {
        var baseResult = _super.prototype.findByName.call(this, name);
        if (baseResult) {
            return baseResult;
        }
        if (this.tileImagery && this.tileImagery.name && this.tileImagery.name == name) {
            return this.tileImagery;
        }
        return null;
    };
    /**
     * Defers rendering of the series
    
    */
    IgrTileSeries.prototype.deferredRefresh = function () {
        this.i.deferredRefresh();
    };
    return IgrTileSeries;
}(IgrShapeSeriesBase));
export { IgrTileSeries };
