import { SeriesViewer } from "igniteui-react-charts";
import { IMapRenderDeferralHandler } from "igniteui-react-core";
import { DependencyProperty } from "igniteui-react-core";
import { DependencyObject } from "igniteui-react-core";
import { MapResizeBehavior } from "./MapResizeBehavior";
import { MapBackgroundTilingMode } from "./MapBackgroundTilingMode";
import { Rect } from "igniteui-react-core";
import { Base, Point, Type, INotifyPropertyChanged, PropertyChangedEventArgs, IEnumerable } from "igniteui-react-core";
import { NumericXAxis } from "igniteui-react-charts";
import { NumericYAxis } from "igniteui-react-charts";
import { Control } from "igniteui-react-core";
import { DomRenderer } from "igniteui-react-core";
import { ScalerParams } from "igniteui-react-charts";
import { Brush } from "igniteui-react-core";
import { Series } from "igniteui-react-charts";
import { SeriesViewerView } from "igniteui-react-charts";
import { Tuple$2 } from "igniteui-react-core";
import { ZoomCoercionMode } from "igniteui-react-charts";
import { ImageTilesReadyEventArgs } from "./ImageTilesReadyEventArgs";
import { FontInfo } from "igniteui-react-core";
import { XamMultiScaleImage } from "igniteui-react-core";
import { XamMultiScaleTileSource } from "igniteui-react-core";
import { DownloadingMultiScaleImageEventArgs } from "igniteui-react-core";
import { CancellingMultiScaleImageEventArgs } from "igniteui-react-core";
import { Size } from "igniteui-react-core";
import { RenderingContext } from "igniteui-react-core";
import { ImagesChangedEventArgs } from "./ImagesChangedEventArgs";
import { HostSeriesView } from "./HostSeriesView";
import { GeographicMapSeriesHost } from "./GeographicMapSeriesHost";
import { SeriesView } from "igniteui-react-charts";
import { ScatterAreaSeries } from "igniteui-react-charts";
import { InteractionState } from "igniteui-react-core";
import { ColorScale } from "igniteui-react-charts";
import { TriangulationStatusEventArgs } from "igniteui-react-core";
/**
 * @hidden
 */
export declare class XamGeographicMap extends SeriesViewer implements IMapRenderDeferralHandler {
    static $t: Type;
    constructor();
    private xw;
    provideContainer(a: any): void;
    n9(): void;
    fl(): boolean;
    fm(): boolean;
    xp: boolean;
    static xh: MapResizeBehavior;
    xi: MapResizeBehavior;
    xl: boolean;
    xm: boolean;
    protected xg(): MapBackgroundTilingMode;
    private xd;
    get xf(): MapBackgroundTilingMode;
    set xf(a: MapBackgroundTilingMode);
    xe: MapBackgroundTilingMode;
    static y4: Rect;
    xs: number;
    xo: boolean;
    xn: boolean;
    zk: Rect;
    private y3;
    get y8(): Rect;
    set y8(a: Rect);
    zc(): Rect;
    private ye;
    private zi;
    get backgroundContent(): GeographicMapImagery;
    set backgroundContent(a: GeographicMapImagery);
    private xa;
    get w7(): NumericXAxis;
    set w7(a: NumericXAxis);
    private w6;
    get w9(): NumericYAxis;
    set w9(a: NumericYAxis);
    private w8;
    xc: GeographicMapImagery;
    private static y7;
    getZoomRectFromGeoRect(a: Rect): Rect;
    yo(a: Rect): void;
    yn(a: Rect): void;
    getZoomFromGeographicRect(a: Rect): Rect;
    y9(a: Rect, b: number): Rect;
    private za;
    getZoomFromGeographicPoints(a: Point, b: Point): Rect;
    ze(a: Rect): Rect;
    y0(a: Point): Point;
    y1(a: Point): Point;
    y2(a: Point): Point;
    yb(): void;
    yh(a: Brush): void;
    gg(): boolean;
    yj(): void;
    protected yz: Point;
    protected ym(): void;
    protected yi(): void;
    protected get_fd(): boolean;
    protected y6: Rect;
    protected wi(): Rect;
    nd(a: Rect, b: ScalerParams): Tuple$2<boolean, number>;
    wt(): Rect;
    private zb;
    protected wj(a: Rect): Rect;
    zd(a: Rect): Rect;
    protected c8(): SeriesViewerView;
    private yd;
    protected qe(a: SeriesViewerView): void;
    qp(a: Rect, b: Rect): void;
    xu: number;
    private xr;
    get xt(): number;
    set xt(a: number);
    hu(): number;
    hv(): number;
    protected rt(): void;
    f4(): boolean;
    cs(): ZoomCoercionMode;
    protected qq(a: any, b: string, c: any, d: any): void;
    imageTilesReady: (sender: any, e: ImageTilesReadyEventArgs) => void;
    private yf;
    private yk;
    private yl;
    xj: XamGeographicMapView;
    private xk;
    getFontInfo(): FontInfo;
    vl(): Brush;
    getFontBrush(): Brush;
    protected rm(a: Series, b: any): void;
    register(a: DependencyObject, b: (arg1: boolean) => void): void;
    unRegister(a: DependencyObject): void;
    deferredRefresh(): void;
    deferAction(a: () => void): void;
    yc(a: boolean): void;
    xx(): any;
    wp(a: Rect, b: Rect, c: Rect): Rect;
    yg(): void;
    private y5;
    protected get zj(): Rect;
    protected set zj(a: Rect);
    yq(a: Rect): void;
    private yp;
    get xq(): boolean;
    static $$p: string[];
}
/**
 * @hidden
 */
export declare abstract class GeographicMapImagery extends Control implements INotifyPropertyChanged {
    static $t: Type;
    constructor(a: XamMultiScaleTileSource);
    protected bb(a: GeographicMapImageryView): void;
    protected ai(): GeographicMapImageryView;
    protected aj: GeographicMapImageryView;
    private ak;
    get deferralHandler(): IMapRenderDeferralHandler;
    set deferralHandler(a: IMapRenderDeferralHandler);
    private a5;
    a9(): void;
    private a3;
    private a2;
    private bg;
    protected ba(a: string, b: any, c: any): void;
    windowRect: Rect;
    get geographicMap(): XamGeographicMap;
    set geographicMap(a: XamGeographicMap);
    static readonly geographicMapProperty: DependencyProperty;
    private static a8;
    private a7;
    clearTileCache(): void;
    imageTilesReady: (sender: any, e: ImageTilesReadyEventArgs) => void;
    private an;
    get ao(): XamMultiScaleImage;
    set ao(a: XamMultiScaleImage);
    ap: XamMultiScaleTileSource;
    propertyChanged: (sender: any, e: PropertyChangedEventArgs) => void;
    bn(a: Size): Size;
    bd(a: RenderingContext): void;
    bf(a: Rect): void;
    be(a: DomRenderer): void;
    imagesChanged: (sender: any, e: ImagesChangedEventArgs) => void;
    private a4;
    a6(): void;
    bc(a: number): void;
    protected v(): void;
    cancellingImage: (sender: any, args: CancellingMultiScaleImageEventArgs) => void;
    downloadingImage: (sender: any, args: DownloadingMultiScaleImageEventArgs) => void;
    referer: string;
    isHorizontalWrappingEnabled: boolean;
    userAgent: string;
    static $$p: string[];
}
/**
 * @hidden
 */
export declare class GeographicMapImageryView extends Base {
    static $t: Type;
    constructor(a: GeographicMapImagery);
    protected a: GeographicMapImagery;
    e(): void;
    protected j: Rect;
    f(a: RenderingContext): void;
    private d;
    g(a: DomRenderer): void;
    h(a: Rect): void;
    private b;
    get c(): number;
    i(a: number): void;
}
/**
 * @hidden
 */
export declare class GeographicXYTriangulatingSeriesView extends HostSeriesView {
    static $t: Type;
    constructor(a: GeographicXYTriangulatingSeries);
    protected cu: GeographicXYTriangulatingSeries;
    ci(): void;
    cx(): void;
    cw(): void;
    cv(): void;
    cy(): void;
    cz(): void;
    c0(): void;
    c1(): void;
}
/**
 * @hidden
 */
export declare class GeographicScatterAreaSeriesView extends GeographicXYTriangulatingSeriesView {
    static $t: Type;
    constructor(a: GeographicScatterAreaSeries);
    private c2;
    a4(): void;
    ci(): void;
    c3(): void;
    c4(): void;
}
/**
 * @hidden
 */
export declare class XamGeographicMapView extends SeriesViewerView {
    static $t: Type;
    constructor(a: XamGeographicMap);
    m(a: boolean): InteractionState;
    bk(a: boolean): void;
    protected fn: XamGeographicMap;
    protected get_ap(): boolean;
    d4(): void;
    du(a: RenderingContext): void;
    protected fz: Rect;
    protected dv(a: Rect): void;
    fy(): Rect;
    fs(): void;
    fx: Brush;
    fw: Brush;
    fo: FontInfo;
    fr(a: Rect): void;
    fu(a: GeographicMapImagery, b: GeographicMapImagery): void;
    private ft;
    protected d1(): void;
    fv(a: number): void;
    private fp;
    get fq(): number;
    set fq(a: number);
}
/**
 * @hidden
 */
export declare class OpenStreetMapImagery extends GeographicMapImagery {
    static $t: Type;
    constructor();
    get tilePath(): string;
    set tilePath(a: string);
    static readonly tilePathProperty: DependencyProperty;
    private static br;
    private bq;
}
/**
 * @hidden
 */
export declare abstract class GeographicXYTriangulatingSeries extends GeographicMapSeriesHost {
    static $t: Type;
    protected ct(): SeriesView;
    q3(a: SeriesView): void;
    xd: GeographicXYTriangulatingSeriesView;
    xh: string;
    xf: string;
    xe: IEnumerable;
    xk: string;
    xm: string;
    xo: string;
    protected rc(a: any, b: string, c: any, d: any): void;
    static $$p: string[];
}
/**
 * @hidden
 */
export declare class GeographicScatterAreaSeries extends GeographicXYTriangulatingSeries {
    static $t: Type;
    protected bk(): Series;
    protected get_ew(): boolean;
    constructor();
    x3: string;
    private xw;
    get xy(): ColorScale;
    set xy(a: ColorScale);
    private x6;
    x8(): void;
    xx: ColorScale;
    protected sl(): void;
    xz: ScatterAreaSeries;
    protected w4(): Series;
    private x7;
    protected ct(): SeriesView;
    q3(a: SeriesView): void;
    x1: GeographicScatterAreaSeriesView;
    protected rc(a: any, b: string, c: any, d: any): void;
    triangulationStatusChanged: (sender: any, args: TriangulationStatusEventArgs) => void;
    protected get_g8(): boolean;
    protected set_g8(a: boolean): void;
    static $$p: string[];
}
