import { IgrStyleShapeEventArgs } from "igniteui-react-charts";
import { IgrGeographicShapeSeriesBase, IIgrGeographicShapeSeriesBaseProps } from "./igr-geographic-shape-series-base";
import { GeographicPolylineSeries } from "./GeographicPolylineSeries";
/**
 * Series class used for displaying multiple polylines, in a geographic context, for datasources which contain multiple lists of points.
*/
export declare class IgrGeographicPolylineSeries extends IgrGeographicShapeSeriesBase<IIgrGeographicPolylineSeriesProps> {
    protected createImplementation(): GeographicPolylineSeries;
    /**
                                 * @hidden
                                 */
    get i(): GeographicPolylineSeries;
    constructor(props: IIgrGeographicPolylineSeriesProps);
    /**
     * Gets whether the current series shows a polyline shape.
    */
    get isPolyline(): boolean;
    /**
     * Gets or sets the fill brush.
    */
    get shapeFill(): string;
    set shapeFill(v: string);
    /**
     * Gets or sets the stroke brush.
    */
    get shapeStroke(): string;
    set shapeStroke(v: string);
    /**
     * Gets or sets the stroke thickness.
    */
    get shapeStrokeThickness(): number;
    set shapeStrokeThickness(v: number);
    /**
     * Gets or sets the opacity.
    */
    get shapeOpacity(): number;
    set shapeOpacity(v: number);
    ensureShapeStyle(): void;
    private _styleShape;
    private _styleShape_wrapped;
    get styleShape(): (s: IgrGeographicPolylineSeries, e: IgrStyleShapeEventArgs) => void;
    set styleShape(ev: (s: IgrGeographicPolylineSeries, e: IgrStyleShapeEventArgs) => void);
}
export interface IIgrGeographicPolylineSeriesProps extends IIgrGeographicShapeSeriesBaseProps {
    /**
     * Gets or sets the fill brush.
    */
    shapeFill?: string;
    /**
     * Gets or sets the stroke brush.
    */
    shapeStroke?: string;
    /**
     * Gets or sets the stroke thickness.
    */
    shapeStrokeThickness?: number | string;
    /**
     * Gets or sets the opacity.
    */
    shapeOpacity?: number | string;
    styleShape?: (s: IgrGeographicPolylineSeries, e: IgrStyleShapeEventArgs) => void;
}
