import { IgrGeographicMapImagery } from "./igr-geographic-map-imagery";
import { IgrShapeSeriesBase, IIgrShapeSeriesBaseProps } from "igniteui-react-charts";
import { TileSeries } from "./TileSeries";
/**
 * Represents a tile series class that can render imagery tiles
*/
export declare class IgrTileSeries extends IgrShapeSeriesBase<IIgrTileSeriesProps> {
    protected createImplementation(): TileSeries;
    /**
                                 * @hidden
                                 */
    get i(): TileSeries;
    constructor(props: IIgrTileSeriesProps);
    /**
     * Gets whether the current series shows a tile imagery.
    */
    get isTile(): boolean;
    /**
     * The MapImagery which is used to provide the tiles for display.
    */
    get tileImagery(): IgrGeographicMapImagery;
    set tileImagery(v: IgrGeographicMapImagery);
    findByName(name: string): any;
    /**
     * Defers rendering of the series
    
    */
    deferredRefresh(): void;
}
export interface IIgrTileSeriesProps extends IIgrShapeSeriesBaseProps {
    /**
     * The MapImagery which is used to provide the tiles for display.
    */
    tileImagery?: IgrGeographicMapImagery;
}
